/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahllokalsystem;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahllokalsystem.boundary.AbstractWahllokalsystemStatusSearchParameters;
import de.ivu.elect.business.wahllokalsystem.boundary.WahllokalsystemStatusChangeEvent;
import de.ivu.elect.business.wahllokalsystem.boundary.WahllokalsystemStatusConversationStore;
import de.ivu.elect.business.wahllokalsystem.boundary.WahllokalsystemStatusExtendedDAO;
import de.ivu.elect.business.wahllokalsystem.boundary.WahllokalsystemStatusSearch;
import de.ivu.elect.business.wahllokalsystem.boundary.WahllokalsystemStatusSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatus;
import de.ivu.elect.business.wahllokalsystem.entity.WahllokalsystemStatusMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWahllokalsystemStatusSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahllokalsystemStatusSearchView.VIEW_ID, useCase = UseCasePermission.WAHLLOKALSYSTEM_STATUS_SEARCH)
public abstract class AbstractWahllokalsystemStatusSearchView extends AbstractElectSearchView<WahllokalsystemStatus> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahllokalsystemStatusSearchView";
  
  public static final String VIEW_ID = "/wahllokalsystem/wahllokalsystem-status-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWahllokalsystemStatusSearchView requestHandler;

  @Inject
  private transient WahllokalsystemStatusExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WahllokalsystemStatusConversationStore.class)
  protected transient WahllokalsystemStatusConversationStore conversationStore;

  @Inject
  protected transient WahllokalsystemStatusSearch search;

  @Inject
  @ConversationGroup(AbstractWahllokalsystemStatusSearchParameters.class)
  protected transient WahllokalsystemStatusSearchParameters searchParameters;

  @Inject
  protected transient WahllokalsystemStatusMeta entityMeta;

  public AbstractWahllokalsystemStatusSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public WahllokalsystemStatus getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(WahllokalsystemStatus entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WahllokalsystemStatusSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<WahllokalsystemStatus> getEagerLoadingCollector() {
    return EagerLoadingCollector.<WahllokalsystemStatus> create();
  }

  @Override
  public List<WahllokalsystemStatus> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<WahllokalsystemStatus> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWahllokalsystemStatusChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahllokalsystemStatusChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWahllokalsystemStatusSearchView {

    @View
    @Inject
    private transient Instance<AbstractWahllokalsystemStatusSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWahllokalsystemStatusSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
